/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleCloudStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleCloudStorageRequest{}

// GoogleCloudStorageRequest struct for GoogleCloudStorageRequest
type GoogleCloudStorageRequest struct {
	Label   *string        `json:"label,omitempty"`
	Type    *string        `json:"type,omitempty"`
	OAuthId *int32         `json:"o_auth_id,omitempty"`
	Bucket  *string        `json:"bucket,omitempty"`
	Path    NullableString `json:"path,omitempty"`
}

// NewGoogleCloudStorageRequest instantiates a new GoogleCloudStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleCloudStorageRequest() *GoogleCloudStorageRequest {
	this := GoogleCloudStorageRequest{}
	return &this
}

// NewGoogleCloudStorageRequestWithDefaults instantiates a new GoogleCloudStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleCloudStorageRequestWithDefaults() *GoogleCloudStorageRequest {
	this := GoogleCloudStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleCloudStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCloudStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleCloudStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleCloudStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *GoogleCloudStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCloudStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *GoogleCloudStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *GoogleCloudStorageRequest) SetType(v string) {
	o.Type = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleCloudStorageRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCloudStorageRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleCloudStorageRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *GoogleCloudStorageRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetBucket returns the Bucket field value if set, zero value otherwise.
func (o *GoogleCloudStorageRequest) GetBucket() string {
	if o == nil || IsNil(o.Bucket) {
		var ret string
		return ret
	}
	return *o.Bucket
}

// GetBucketOk returns a tuple with the Bucket field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCloudStorageRequest) GetBucketOk() (*string, bool) {
	if o == nil || IsNil(o.Bucket) {
		return nil, false
	}
	return o.Bucket, true
}

// HasBucket returns a boolean if a field has been set.
func (o *GoogleCloudStorageRequest) HasBucket() bool {
	if o != nil && !IsNil(o.Bucket) {
		return true
	}

	return false
}

// SetBucket gets a reference to the given string and assigns it to the Bucket field.
func (o *GoogleCloudStorageRequest) SetBucket(v string) {
	o.Bucket = &v
}

// GetPath returns the Path field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GoogleCloudStorageRequest) GetPath() string {
	if o == nil || IsNil(o.Path.Get()) {
		var ret string
		return ret
	}
	return *o.Path.Get()
}

// GetPathOk returns a tuple with the Path field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GoogleCloudStorageRequest) GetPathOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Path.Get(), o.Path.IsSet()
}

// HasPath returns a boolean if a field has been set.
func (o *GoogleCloudStorageRequest) HasPath() bool {
	if o != nil && o.Path.IsSet() {
		return true
	}

	return false
}

// SetPath gets a reference to the given NullableString and assigns it to the Path field.
func (o *GoogleCloudStorageRequest) SetPath(v string) {
	o.Path.Set(&v)
}

// SetPathNil sets the value for Path to be an explicit nil
func (o *GoogleCloudStorageRequest) SetPathNil() {
	o.Path.Set(nil)
}

// UnsetPath ensures that no value is present for Path, not even an explicit nil
func (o *GoogleCloudStorageRequest) UnsetPath() {
	o.Path.Unset()
}

func (o GoogleCloudStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleCloudStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Bucket) {
		toSerialize["bucket"] = o.Bucket
	}
	if o.Path.IsSet() {
		toSerialize["path"] = o.Path.Get()
	}
	return toSerialize, nil
}

type NullableGoogleCloudStorageRequest struct {
	value *GoogleCloudStorageRequest
	isSet bool
}

func (v NullableGoogleCloudStorageRequest) Get() *GoogleCloudStorageRequest {
	return v.value
}

func (v *NullableGoogleCloudStorageRequest) Set(val *GoogleCloudStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleCloudStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleCloudStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleCloudStorageRequest(val *GoogleCloudStorageRequest) *NullableGoogleCloudStorageRequest {
	return &NullableGoogleCloudStorageRequest{value: val, isSet: true}
}

func (v NullableGoogleCloudStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleCloudStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
